<template>
  <div class="header_nox">
    <el-button type="warning" circle @click="exportWord">下载</el-button>
    <el-button
      type="primary"
      circle
      v-show="!editable"
      @click="editable = !editable"
      >编辑</el-button
    >
    <el-button type="primary" v-show="editable" @click="saveData"
      >确定</el-button
    >
  </div>

  <div id="printContent" ref="imageWrapper">
    <h3>剪板机工序生产质量记录表</h3>
    
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
       
                <!-- <el-input
                  size="small"
                  v-model="headData.head.reportTime"
                  :placeholder="`请输入${headData.head.reportTime}`"
                /> -->
           
        <span>日期：</span>
        <span>{{ headData.head.reportTime1 }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>

      <!-- <div class="title_form_input">
          <span>生产线：</span>
          <span>四线</span>
        </div> -->
    </div>
    <el-divider />
    <HJTABLE
      :SClist="SClist"
      :tableHeader="tableHeader"
      :labelName="labelName.b1"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="selfList"
      :tableHeader="selfHeader"
      :labelName="labelName.b2"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="checkList"
      :tableHeader="checkHeader"
      :labelName="labelName.b3"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="rdList"
      :tableHeader="rdHeader"
      :labelName="labelName.b4"
      :editable="editable"
    ></HJTABLE>

    <div id="divcss"><p>4.抽检记录2：</p></div>
    <div v-for="(ii, kk) in eloList" :key="kk">
      <el-row>
        <el-col :span="6" v-for="(i, k) in ii" :key="k">
          <HJTABLE
            :SClist="i.list"
            :tableHeader="rd2Header"
            :editable="editable"
          ></HJTABLE>
        </el-col>
      </el-row>
    </div>
    <HJTABLE
      :SClist="jFList"
      :tableHeader="fpHeader"
      :labelName="labelName.b6"
      :editable="editable"
    ></HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { jianbjVoLast, save } from "@/api/JBapi";
import { headReport } from "@/api/head";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import { useRouter } from "vue-router";
import HJTABLE from "@/components/arj/arj-table";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  methods: {},
  setup(props) {
    const router = useRouter();

    const fpHeader = reactive([
      {
        prop: "pihao",
        label: "批号",
        editable: true,
        type: "text",
      },
      // {
      //   prop: "biaoshi",
      //   label: "标识",
      //   editable: false,
      //   type: "text",
      // },
      {
        prop: "scfpmc",
        label: "生产废品名称",
        editable: true,
        type: "input",
      },
      {
        prop: "shengchanFp",
        label: "数量",
        editable: true,
        type: "input",
      },
      {
        prop: "ytfpmc",
        label: "印铁废品名称",
        editable: true,
        type: "input",
      },
      {
        prop: "yintieFp",
        label: "数量",
        editable: true,
        type: "input",
      },
    ]);
    const rd2Header = reactive([
      {
        prop: "shijian3",
        label: "时间",
        editable: false,
        type: "text",
      },
      // {
      //   prop: "biaoshi",
      //   label: "标识",
      //   editable: false,
      //   type: "text",
      // },

      {
        prop: "changdu",
        label: "长度",
        editable: false,
        type: "input",
      },
      {
        prop: "kuandu",
        label: "宽度",
        editable: false,
        type: "input",
      },
      {
        prop: "zhijiaodu",
        label: "直角度",
        editable: false,
        type: "input",
      },
    ]);
    const tableHeader = reactive([
      {
        prop: "ytphBh",
        label: "原铁批号、版号",
        editable: false,
        type: "input",
      },
      {
        prop: "yscj",
        label: "印刷厂家",
        editable: false,
        type: "input",
      },
      {
        prop: "cjsj2",
        label: "裁剪时间",
        editable: false,
        type: "input",
      },
      {
        prop: "ytsl",
        label: "原铁数量",
        editable: false,
        type: "input",
      },
      {
        prop: "scsl",
        label: "实剪数量",
        editable: false,
        type: "input",
      },
      {
        prop: "kuiying",
        label: "亏盈",
        editable: false,
        type: "input",
      },
      ,
      {
        prop: "stcj",
        label: "素铁厂家",
        editable: false,
        type: "input",
      },
      {
        prop: "ttsl",
        label: "退铁数量",
        editable: false,
        type: "input",
      },
      {
        prop: "yuanyin",
        label: "原因",
        editable: false,
        type: "input",
      },
      {
        prop: "ttmc",
        label: "退铁名称",
        editable: false,
        type: "input",
      },
    ]);
    const selfHeader = reactive([
      {
        prop: "cpml",
        label: "产品名称",
        editable: false,
        type: "input",
      },
      {
        prop: "changdu",
        label: "长度",
        editable: false,
        type: "input",
      },
      {
        prop: "gaodu",
        label: "高度",
        editable: false,
        type: "input",
      },
      {
        prop: "zhijiaodu",
        label: "直角度",
        editable: false,
        type: "input",
      },
    ]);
    const checkHeader = reactive([
      {
        prop: "cjffNum",
        label: "抽检数量",
        editable: false,
        type: "input",
      },
      {
        prop: "cjffFre",
        label: "抽检频率",
        editable: false,
        type: "input",
      },
      {
        prop: "cjffCheckOne",
        label: "检测点1",
        editable: false,
        type: "input",
      },
      {
        prop: "cjffCheckTwo",
        label: "检测点2",
        editable: false,
        type: "input",
      },
      {
        prop: "cjffCheckThree",
        label: "检测点3",
        editable: false,
        type: "input",
      },
    ]);
    const rdHeader = reactive([
      {
        prop: "shijian2",
        label: "时间",
        editable: false,
        type: "text",
      },
      {
        prop: "yszl",
        label: "印刷质量",
        editable: false,
        type: "input",
      },
      {
        prop: "liukong",
        label: "留空",
        editable: false,
        type: "input",
      },
      {
        prop: "nwths",
        label: "内外涂划伤",
        editable: false,
        type: "input",
      },
    ]);
    let tableData = reactive([]);
    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });
    let hanjiRdData = reactive({
      jianbjTrjl: {},
      jianbjSelf: {},
      jianbjCheck: {},
      jianbjRd: {},
      jianbjRd2List: {},
      jianbjFpList: {},
    });

    let editable = ref(false);
    let SClist = ref([]);
    let hjData = ref({});

    let selfList = ref([]);
    let checkList = ref([]);
    let rdList = ref([]);
    //分解成两个12子list，因为打印需要
    let rdList1 = ref([]);
    let rdList2 = ref([]);

    let rd2List = ref([]);
    let jFList = ref([]);

    let rd2ListA1 = ref([]);
    let rd2ListB1 = ref([]);
    let rd2ListC1 = ref([]);
    let rd2ListD1 = ref([]);

    let rd2ListA2 = ref([]);
    let rd2ListB2 = ref([]);
    let rd2ListC2 = ref([]);
    let rd2ListD2 = ref([]);

    let rd2ListA3 = ref([]);
    let rd2ListB3 = ref([]);
    let rd2ListC3 = ref([]);
    let rd2ListD3 = ref([]);

    let eloList = ref([]);
    let eloName = ref(["A", "B", "C", "D"]);

    let labelName = {
      b1: "原材料投入记录",
      b2: "1.岗位各产品尺寸标准：",
      b3: "2.抽检方法：",
      b4: "3.抽检记录1：（30分钟抽检1次（每包铁上、中、下各一次），√代表质量良好，如有质量缺陷直接注明",
      b5: "顶球撕拉实验",
      b6: "废品记录",
    };

    const submitForm = () => {};

    const saveData = async () => {
      editable = false;
      let data = {
        jianbjTrjl: SClist.value,
        jianbjSelf: selfList.value,
        jianbjCheck: checkList.value,
        jianbjRd: rdList.value,
        jianbjRd2List: rd2ListA1.value.concat(
          rd2ListB1.value,
          rd2ListC1.value,
          rd2ListD1.value,
          rd2ListA2.value,
          rd2ListB2.value,
          rd2ListC2.value,
          rd2ListD2.value,
          rd2ListA3.value,
          rd2ListB3.value,
          rd2ListC3.value,
          rd2ListD3.value
        ),
        jianbjFpList: jFList.value,
        head: headData.head,
      };
      console.log("save data...", data);
      const dt = await save(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      console.log(dt);
    };
    const handleEdit = (row) => {
      editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };
    const getListData = async () => {
      const data = await jianbjVoLast();
      parse(data);
    };

    const getRouterData = async (req) => {
      console.log("req....", req);
      const data = await headReport(req);
      console.log("jbj router data.....", data);

      parse(data);
    };

    function rd2Filter(biaoshi) {
      var list = rd2List.value.filter((item) => {
        return item.biaoshi === biaoshi;
      });
      return list;
    }
    function parse(data) {
      console.log('jbj...',data)
      headData.head = data.data.head;
      headData.head.reportTime1 = headData.head.reportTime.substr(0, 10);

      hanjiRdData.jianbjTrjl = data.data.jianbjTrjl;

      hjData.value = { ...headData.head, ...hanjiRdData.jianbjTrjl };

      SClist.value = data.data.jianbjTrjl;
      SClist.value.filter((item) => {
        item.cjsj2 = item.cjsj.substr(11, 5);

        return item;
      });
      selfList.value = data.data.jianbjSelf;
      checkList.value = data.data.jianbjCheck;
      rdList.value = data.data.jianbjRd;
      rdList.value.filter((item) => {
        item.shijian2 = item.shijian.substr(11, 5);

        return item;
      });
      rd2List.value = data.data.jianbjRd2List;
      rd2List.value.filter((item) => {
        item.shijian3 = item.shijian.substr(11, 5);

        return item;
      });
      jFList.value = data.data.jianbjFpList;

      if (rdList.value.length > 12) {
        rdList1 = rdList.value.splice(0, 11);
        rdList2 = rdList.value.splice(12);
      } else {
        rdList1 = rdList;
        rdList2 = [];
      }

      rd2ListA1.value = rd2Filter("A1");
      rd2ListA2.value = rd2Filter("A2");
      rd2ListA3.value = rd2Filter("A3");

      rd2ListB1.value = rd2Filter("B1");
      rd2ListB2.value = rd2Filter("B2");
      rd2ListB3.value = rd2Filter("B3");

      rd2ListC1.value = rd2Filter("C1");
      rd2ListC2.value = rd2Filter("C2");
      rd2ListC3.value = rd2Filter("C3");

      rd2ListD1.value = rd2Filter("D1");
      rd2ListD2.value = rd2Filter("D2");
      rd2ListD3.value = rd2Filter("D3");
      eloList.value = [
        [
          { list: rd2ListA1.value, name: "A" },
          { list: rd2ListB1.value, name: "B" },
          { list: rd2ListC1.value, name: "C" },
          { list: rd2ListD1.value, name: "D" },
        ],
        [
          { list: rd2ListA2.value, name: "A" },
          { list: rd2ListB2.value, name: "B" },
          { list: rd2ListC2.value, name: "C" },
          { list: rd2ListD2.value, name: "D" },
        ],
        [
          { list: rd2ListA3.value, name: "A" },
          { list: rd2ListB3.value, name: "B" },
          { list: rd2ListC3.value, name: "C" },
          { list: rd2ListD3.value, name: "D" },
        ],
      ];

      console.log(rd2ListA1);
      console.log(rd2ListB1);
    }
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "剪板机工序生产质量记录表"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("jbj.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象
        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });

        // 设置模板变量的值
        doc.setData({
          ...hjData.value,

          table: hanjiRdData.jianbjTrjl,
          table2: selfList.value,
          table3: rdList1.value,
          table31: rdList2.value,
          t4: rd2ListA1.value,
          t5: rd2ListB1.value,
          t6: rd2ListC1.value,
          t7: rd2ListD1.value,
          t8: rd2ListA2.value,
          t9: rd2ListB2.value,
          ta: rd2ListC2.value,
          tb: rd2ListD2.value,
          tc: rd2ListA3.value,
          td: rd2ListB3.value,
          te: rd2ListC3.value,
          tf: rd2ListD3.value,
          tt1: rd2ListA1.value.length == 0 ? "" : rd2ListA1.value[0].shijian,
          tt2: rd2ListA2.value.length == 0 ? "" : rd2ListA2.value[0].shijian,
          tt3: rd2ListA3.value.length == 0 ? "" : rd2ListA3.value[0].shijian,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "剪板机工序生产质量记录表.docx");
      });
    }

    onMounted(() => {
      console.log("rrrrrrrrrrr", router.currentRoute.value.query);
      let head_id = router.currentRoute.value.query.id;
      let leixing = router.currentRoute.value.query.leixing;
      console.log("vue recv....", head_id, leixing);
      if (head_id == null) {
        getListData();
      } else {
        getRouterData({ head_id: head_id, leixing: leixing });
      }
    });
    return {
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      tableHeader,
      selfHeader,
      checkHeader,
      rdHeader,
      getListData,
      headData,
      toImage,
      imageWrapper,
      SClist,
      selfList,
      checkList,
      rdList,
      exportWord,
      editable,
      saveData,
      headReport,
      rd2Header,
      rd2List,
      rd2ListA1,
      rd2ListC1,
      rd2ListB1,
      rd2ListD1,
      jFList,
      fpHeader,
      rd2ListA2,
      rd2ListB2,
      rd2ListC2,
      rd2ListD2,
      rd2ListA3,
      rd2ListB3,
      rd2ListC3,
      rd2ListD3,
      eloList,
      eloName,
      labelName,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}
#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}
.header_nox2 {
  text-align: right;
}
#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}
.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}
.title_form_input {
  font-size: 16px;
}
#divcss p {
  font-size: 20px;
  text-align: left;
}
</style>
